

local tUniqueImpPlots = {};
local iUniqueImpType = -1;
local iCityConquerer = -1;
local tPlayerIDimpID = {}; 
local tBuggedCivs = {'CIVILIZATION_NUBIA', 'CIVILIZATION_INDONESIA', 'CIVILIZATION_PERSIA', 'CIVILIZATION_SCOTLAND', 'CIVILIZATION_CREE', 'CIVILIZATION_NETHERLANDS'};
local tBuggedImps = {'IMPROVEMENT_PYRAMID', 'IMPROVEMENT_KAMPUNG', 'IMPROVEMENT_PAIRIDAEZA', 'IMPROVEMENT_GOLF_COURSE', 'IMPROVEMENT_MEKEWAP', 'IMPROVEMENT_POLDER'};
local tBuggedImpIDplayerID = {}; -- imp thar need fix


local function GetUniqueImpType(iPlayer)

	local sCivType = PlayerConfigurations[iPlayer]:GetCivilizationTypeName();
	-- iUniqueImpType = -1;

	for row in GameInfo.NSUI_CivType_UniqueImpType() do
		if row.CivType == sCivType then
			return GameInfo.Improvements[row.UniqueImpType].Index;
		end
	end
		
	return -1;
end


local function OnCityInitialized(iOwnerID, iCityID)

	if iUniqueImpType == -1 or iOwnerID ~= iCityConquerer then
		CleanUp();
		return;
	end
	-- local pCity = Players[iOwnerID]:GetCities():FindID( iCityID );
	-- local pCityPlot = Map.GetPlot(pCity:GetX(), pCity:GetY());	
	-- local iCityPlotID = pCityPlot:GetIndex();
	-- print(pCity:GetName(), ' Initialized');
	for _, pPlot in pairs(tUniqueImpPlots) do
		print("Placing ", GameInfo.Improvements[iUniqueImpType].ImprovementType, pPlot:GetX(), pPlot:GetY() );

		if tBuggedImpIDplayerID[iUniqueImpType] then
			ImprovementBuilder.SetImprovementType(pPlot, iUniqueImpType, tBuggedImpIDplayerID[iUniqueImpType]);
			print("bugged improvement !!!!!!!!!!");
		else
			ImprovementBuilder.SetImprovementType(pPlot, iUniqueImpType, iOwnerID);

		end
		ImprovementBuilder.SetImprovementPillaged(pPlot, true);
	end


	CleanUp();
end


local function OnImprovementRemovedFromMap( iPlotX, iPlotY, iOwnerID)
	
	local pPlot = Map.GetPlot(iPlotX, iPlotY);	

	if iUniqueImpType == -1 or pPlot:GetOwner() ~= iCityConquerer then
		CleanUp();
		return;
	end

	-- print(' Improvement Removed From Map', 'plotowner', pPlot:GetOwner());
	if pPlot:GetImprovementType() == -1 then
		print(' Unique Improvement Removed From Map', iPlotX, iPlotY);
		table.insert(tUniqueImpPlots, pPlot);
	end

	-- if #tUniqueImpPlots > 0 then
		-- Events.CityInitialized.Add(OnCityInitialized );
	-- end
end


function CleanUp()
	print("NSUI CleanUp ");
	Events.ImprovementRemovedFromMap.Remove(OnImprovementRemovedFromMap );
	Events.CityInitialized.Remove(OnCityInitialized );
	iUniqueImpType = -1;
	tUniqueImpPlots = {};
	iCityConquerer = -1;
end


local function OnCityConquered(iCapturerID, iOwnerID, iCityID , iCityX, iCityY)
	-- Events.ImprovementRemovedFromMap.Remove(OnImprovementRemovedFromMap );
	local pCity = Players[iCapturerID]:GetCities():FindID( iCityID );
	print(pCity:GetName(), ' Conquered');
	print(' Conquerer ID', iCapturerID);
	-- GetUniqueImpType(iOwnerID);

	-- if iUniqueImpType > -1 then 
	if tPlayerIDimpID[iOwnerID] then 
		print(' Unique imp civ', iOwnerID, tPlayerIDimpID[iOwnerID]);
		iUniqueImpType = tPlayerIDimpID[iOwnerID];
		iCityConquerer = iCapturerID;
		Events.ImprovementRemovedFromMap.Add(OnImprovementRemovedFromMap );
		Events.CityInitialized.Add(OnCityInitialized );
	else
		CleanUp();
	end
	-- Events.PlayerTurnDeactivated.Add( OnPlayerTurnDeactivated );
end


local function Initialize()

	for iPlayerID, pPlayer in  ipairs(Players) do
		-- if pPlayer:WasEverAlive() and pPlayer:IsAlive() then
		if pPlayer:WasEverAlive() then
			-- print(  'iPlayerID', iPlayerID);
			-- local pPlayerConfig = PlayerConfigurations[iPlayerID];
			local iUniqueImp = GetUniqueImpType(iPlayerID);

			if iUniqueImp > -1 then
				local sCivName = PlayerConfigurations[iPlayerID]:GetCivilizationTypeName();
				tPlayerIDimpID[iPlayerID] = iUniqueImp;
				print('iUniqueImp', sCivName, iPlayerID, GameInfo.Improvements[iUniqueImp].ImprovementType, iUniqueImp);

				for _, value in pairs(tBuggedCivs) do
					if value == sCivName then
						tBuggedImpIDplayerID[iUniqueImp] = iPlayerID;
						print( ' bugged ', sCivName, GameInfo.Improvements[iUniqueImp].ImprovementType, iUniqueImp);
						break;
					end
				end
			end
		end
	end

	GameEvents.CityConquered.Add(OnCityConquered);
	print( ' NSUI LOADED ');
end
Events.LoadScreenClose.Add(Initialize);

-- function OnCityBuilt( playerID: number, cityID : number, cityX : number, cityY : number )
	-- local pCity = Players[playerID]:GetCities():FindID( cityID );
	-- print("OnCityBuilt  " .. pCity:GetName());

-- end
-- GameEvents.CityBuilt.Add(OnCityBuilt );


-- function OnCityAddedToMap(playerID, cityID, x, y)
	-- local pCity = Players[playerID]:GetCities():FindID( cityID );
	-- print("CityAddedToMap  " .. pCity:GetName());
-- end
-- Events.CityAddedToMap.Add( OnCityAddedToMap );
